
#include "ThreadNaming.hh"

#include <windows.h>

/// author Jan Woetzel, 2005


#define MS_VC_EXCEPTION 0x406d1388

// helper struct 
typedef struct tagTHREADNAME_INFO
{
	DWORD dwType;        // must be 0x1000
	LPCSTR szName;       // pointer to name (in same addr space)
	DWORD dwThreadID;    // thread ID (-1 caller thread)
	DWORD dwFlags;       // reserved for future use, most be zero
} THREADNAME_INFO;

// JW public interface 
void BIAS::SetThreadName(const unsigned long dwThreadID, const char* szThreadName )
{
	if (szThreadName==NULL) return; // invalid name

	THREADNAME_INFO info;
	info.dwType = 0x1000;
	info.szName = szThreadName;
	info.dwThreadID = dwThreadID;
	info.dwFlags = 0;

	try {
		// post an exception to Visual studio to change the thread name. (JW) 
		RaiseException(
			MS_VC_EXCEPTION, 
			0, 
			sizeof(info) / sizeof(DWORD), 
			(DWORD *)&info
			);
	} 
	catch (int) 
	{
		//cerr<<FUNCNAME<<"not working."<<endl;
#ifdef BIAS_DEBUG
		DebugBreak();
#endif
	}
}

