#include "TimeMeasure.hh"

using namespace std;
using namespace BIAS;

// this file only to instantiate this static member:
std::ofstream BIAS::TimeMeasure::TimerStream_;


// JW
//static 
void TimeMeasure::MSecondsToHumanReadable(
  const unsigned long & msIN,
  int & msecOUT,
  int & seconds,
  int & minutes,
  int & hours,
  int & days,
  int & weeks 
  )
{     
  unsigned long rest = msIN; // remainder

  msecOUT = rest % 1000; // 1000 msec each second
  rest -= msecOUT;
  rest /= 1000; // now seconds

  seconds = rest % 60; // 60 seconds each minute
  rest -= seconds;
  rest /= 60; // now minutes

  minutes = rest % 60;// 60 minutes each hour
  rest -= minutes;
  rest /= 60; // now hours

  hours = rest % 24;// 24 hours each day
  rest -= hours;
  rest /= 24; // now days

  days = rest % 7;// 7 days a week
  rest -= days;
  rest /= 7; // now week

  weeks = rest;
  // do not split further 
  // because days pe rmonth vary (28-31 days, const 365 day year is too long for me to wait anyhow ;-)
}

//JW
//static 
std::ostream & TimeMeasure::PrintMsecHumanReadable(const unsigned long msecIN, 
                                                   std::ostream &os)
{
  int ms, sec, minutes, hh, dd, ww;
  MSecondsToHumanReadable(msecIN, ms, sec, minutes, hh, dd, ww);

  bool display=false;
  if (ww>0) display=true;
  if (display) os<<setw(3)<<ww<<" weeks ";

  if (hh>0) display=true;
  if (display) os<<setw(3)<<dd<<" days ";

  if (dd>0) display=true;
  if (display) os<<setw(3)<<hh<<" hours ";

  if (minutes>0) display=true;
  if (display) os<<setw(3)<<minutes<<" minutes ";

  if (sec>0) display=true;
  if (display) os<<setw(3)<<sec<<" sec ";
  
  if (!display){
    // display zero at least:
    os<<setw(3)<<ms<<" msec";
  } else if (ms>0){
    // suppress displaying 0 msec.
    os<<setw(3)<<ms<<" msec";
  };

  return os;
}

