#ifndef __EuclideanTransf3D_hh__
#define __EuclideanTransf3D_hh__

#include "Base/Math/Matrix4x4.hh"
#include "Base/Math/Vector3.hh"
#include "Base/Geometry/RMatrixBase.hh"

namespace BIAS {

  /** @class EuclideanTransf3D
      @ingroup g_geometry
      @brief Euclidean transformation for 3D points
      @author woelk 08/2004 */
  class BIASGeometryBase_EXPORT EuclideanTransf3D : public Matrix4x4<double>
  {
  public:
    EuclideanTransf3D();
    ~EuclideanTransf3D();

    void Set(RMatrixBase& R, Vector3<double>& t);
    
    void SetXYZ(Vector3<double>& EulerAng, Vector3<double>& t);

  protected:
    

  }; // class

} // namespace



#endif // __EuclideanTransf3D_hh__
