/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "HomgPoint2D.hh"
#include <float.h>

using namespace BIAS;
using namespace std;

ostream& operator<<(ostream& os, const enum HomgPoint2D::EPosition pos)
{
  switch(pos){
  case HomgPoint2D::TopLeft: os << "topleft"; break;
  case HomgPoint2D::Top: os << "top"; break;
  case HomgPoint2D::TopRight: os << "topright"; break;
  case HomgPoint2D::Left: os << "left"; break;
  case HomgPoint2D::Center: os << "center"; break;
  case HomgPoint2D::Right: os << "right"; break;
  case HomgPoint2D::BottomLeft: os << "bottomleft"; break;
  case HomgPoint2D::Bottom: os << "bottom"; break;
  case HomgPoint2D::BottomRight: os << "bottomright"; break;
  case HomgPoint2D::Infinity: os << "infinity"; break;
  case HomgPoint2D::InvalidPosition: os << "invalid"; break;
  }
  return os;
}

/*
ostream& operator<<(ostream& os, const BIAS::HomgPoint2D p2D){
#ifdef BIAS_DEBUG
  std::streambuf *OutBuf_=std::cout.rdbuf(), *OsBuf_= os.rdbuf(), 
    *ErrBuf_=std::cerr.rdbuf();
  
  // print size at first to be compatible to Vector<>
  if (OutBuf_!=OsBuf_ && ErrBuf_!=OsBuf_){ // not cout and not cerr
#endif
      os << VECTOR3_SIZE << std::endl;	
      os << std::setw(14);		// set width for output format
      if (fabs(p2D[2]) > DBL_EPSILON) 
        os << "[ " << p2D[0]/p2D[2] << "  " <<  p2D[1]/p2D[2] << "  1.0 ]";
      else
        os << "[ " << p2D[0] << "  " <<  p2D[1] << "  " << p2D[2] << "  ]";
      os << std::endl;
#ifdef BIAS_DEBUG
  } else {
      // cout or cerr
    
    if (fabs(p2D[2]) > DBL_EPSILON) 
      os << "[ " << std::setprecision(10) << p2D[0]/p2D[2] << "  " 
         << std::setprecision(10) << p2D[1]/p2D[2] << "  1.0 ]";
    else
      os << "[ " << std::setprecision(10) << p2D[0] << "  "
         << std::setprecision(10) <<  p2D[1] << "  " 
         << std::setprecision(10)<< p2D[2] << "  ]";
  }
#endif  
  return os;
  }
*/
