/** @example ExampleIplImageDisplay.cpp
    howto display a BIAS image using OpenCV.
    @author Jan Woetzel 2005 
*/

#include <iostream>
#include <string> 

// BIAS
#include <Base/Image/Image.hh>
#include <Base/Image/ImageIO.hh>

using namespace std;
using namespace BIAS;


int main( int argc, char** argv )
{
    //
    // load image (prerquisit): 
    //
    bool darttestNoGui=false;
    bool darttestGui=false;
    int  delay=2000;
    string filename( BIAS_TESTS_DATA "r4.jpg" );
    if (argc>=2) {
        if ((strcmp(argv[1],"-darttest")==0)
            || (strcmp(argv[1],"-darttestnogui")==0) )
        {
            darttestNoGui=true;
            std::cout<<"started dart test (no gui): "<<argv[0]<<std::endl;
        } else if (strcmp(argv[1],"-darttestgui")==0) {
            darttestGui=true;
            delay=500; // msec is enough for test
            std::cout<<"started dart test (with gui): "<<argv[0]<<std::endl;
        }
    };
    // user specified an image to work with: 
    if (!darttestNoGui && !darttestGui && (argc>1)) filename=argv[1];
    // laod an image to work with
    BIAS::Image<unsigned char> img;
    if (BIAS::ImageIO::Load(filename, img) !=0){
        cout<<"error loading image "<<filename<<endl;
        return -1;
    };
    cout<<"loaded image with dim: "<<img.GetWidth()<<"x"<<img.GetHeight()<<endl;


    //
    // major test: the Display routine: 
    //
    if (!darttestNoGui) {
        img.Display("Display", true, true, true, delay );
    }
    
    return 0;
}
