/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef _Cholesky_hh_
#define _Cholesky_hh_

#include "bias_config.h" 
#include <Base/Debug/Error.hh>
#include <Base/Math/Matrix.hh>
#include "tnt/cholesky.h"

namespace BIAS {

  class BIASMathBase_EXPORT Cholesky
  {
  public:
    explicit Cholesky(Matrix<double> &A);
    ~Cholesky() {};

    bool decompositionExists();
    Matrix<double> upperTriangle();

  private:
    Matrix<double> L;
    bool exists;
  };
};

#endif /* _Cholesky_hh_ */
