## 
## Try to find CG from Nvidia 
## Once run this will define: 
## 
## CGGL_FOUND
## CGGL_INCLUDE_DIR
## CGGL_LIBRARIES    
##
##  (CGGL_LINK_DIRECTORIES: not yet...)
##
## please keep in mind that cgc(.exe) may be required in path at runtime
##
## Jan Woetzel 2003-2005
## www.mip.informatik.uni-kiel.de/~jw
##
## TODO: 
## -add paths from registry for WIN32
## 


## check OS: 
IF (NOT UNIX)
  IF (NOT WIN32)
    MESSAGE(SEND_ERROR "Sorry, FindCGGL supports only WIN32 and UNIX/LINUX, currently.")
  ENDIF (NOT WIN32)
ENDIF (NOT UNIX)


FIND_PATH(CG_CORE_INCLUDE_DIR Cg/cg.h
  $ENV{CG_INC_PATH}
  $ENV{CG_HOME}/include
  /usr/include
  /usr/local/include
  /opt/net/gcc33/Cg/include
  "$ENV{ProgramFiles}/NVIDIA Corporation/Cg/include"
  )
#MESSAGE("DBG CG_CORE_INCLUDE_DIR=${CG_CORE_INCLUDE_DIR}")

FIND_PATH(CG_GL_INCLUDE_DIR Cg/cgGL.h
  "$ENV{CG_INC_PATH}"
  "$ENV{CG_HOME}/include"
  /usr/include
  /usr/local/include
  /opt/net/gcc33/Cg/include
  "$ENV{ProgramFiles}/NVIDIA Corporation/Cg/include"
  )
#MESSAGE("DBG CG_GL_INCLUDE_DIR=${CG_GL_INCLUDE_DIR}")

FIND_LIBRARY(CG_CORE_LIBRARY
  NAMES Cg cg
  PATHS 
  "$ENV{CG_LIB_PATH}"
  "$ENV{CG_HOME}/lib"
  /usr/lib
  /usr/local/lib
  /opt/net/gcc33/Cg/lib
  "$ENV{ProgramFiles}/NVIDIA Corporation/Cg/lib"
  )
#MESSAGE("DBG CG_CORE_LIBRARY=${CG_CORE_LIBRARY}")

FIND_LIBRARY(CG_GL_LIBRARY
  NAMES CgGL cggl
  PATHS 
  $ENV{CG_LIB_PATH}
  $ENV{CG_HOME}/lib
  /usr/lib
  /usr/local/lib
  /opt/net/gcc33/Cg/lib
  "$ENV{ProgramFiles}/NVIDIA Corporation/Cg/lib"
  )
#MESSAGE("DBG CG_GL_LIBRARY=${CG_GL_LIBRARY}")




IF(CG_CORE_LIBRARY AND CG_GL_LIBRARY)
  # OK.
  SET(CGGL_LIBRARIES ${CG_CORE_LIBRARY} ${CG_GL_LIBRARY})
ELSE(CG_CORE_LIBRARY AND CG_GL_LIBRARY)
  IF(NOT CG_CORE_LIBRARY)
    MESSAGE(SEND_ERROR "CG core library not found.")
  ENDIF(NOT CG_CORE_LIBRARY)
  IF(NOT CG_GL_LIBRARY)
    MESSAGE(SEND_ERROR "CG GL library not found.")
  ENDIF(NOT CG_GL_LIBRARY)
ENDIF(CG_CORE_LIBRARY AND CG_GL_LIBRARY)

IF(CG_CORE_INCLUDE_DIR AND CG_GL_INCLUDE_DIR)

  ## OK.
  SET(CGGL_INCLUDE_DIR "${CG_CORE_INCLUDE_DIR}" "${CG_GL_INCLUDE_DIR}" )

ELSE(CG_CORE_INCLUDE_DIR AND CG_GL_INCLUDE_DIR)
  IF(NOT CG_CORE_INCLUDE_DIR)
    MESSAGE(SEND_ERROR "CG core include dir not found.")
  ENDIF(NOT CG_CORE_INCLUDE_DIR)
  IF(NOT CG_GL_INCLUDE_DIR)
    MESSAGE(SEND_ERROR "CG GL include dir not found.")
  ENDIF(NOT CG_GL_INCLUDE_DIR)
ENDIF(CG_CORE_INCLUDE_DIR AND CG_GL_INCLUDE_DIR)


IF(CGGL_LIBRARIES AND CGGL_INCLUDE_DIR)
  SET(CGGL_FOUND TRUE)
ELSE(CGGL_LIBRARIES AND CGGL_INCLUDE_DIR)
  SET(CGGL_FOUND FALSE)
ENDIF(CGGL_LIBRARIES AND CGGL_INCLUDE_DIR)


MARK_AS_ADVANCED(
  CG_CORE_INCLUDE_DIR
  CG_GL_INCLUDE_DIR
  CG_CORE_LIBRARY
  CG_GL_LIBRARY
  CGGL_INCLUDE_DIR
  CGGL_LIBRARIES
  )
