## 
## Try to find GLEW library  
## Once run this will define: 
## 
## GLEW_FOUND
## GLEW_INCLUDE_DIR
## GLEW_LIBRARIES
##
##  (GLEW_LINK_DIRECTORIES: not yet...)
##
## Jan Woetzel 09/2003. 
## www.mip.informatik.uni-kiel.de/~jw
## --------------------------------

FIND_PATH(GLEW_INCLUDE_DIR GL/glew.h
  $ENV{GLEW_HOME}/include
  $ENV{GLEW_DIR}/include
  $ENV{EXTRA}/include
  $ENV{EXTRA}
  $ENV{SOURCE_DIR}/glew/include
  $ENV{SOURCE_DIR}/glew/
  C:/source/glew/include
  D:/source/glew/include
  /opt/net/gcc33/glew/include
  /usr/include
  /usr/local/include
  )
#MESSAGE("DBG GLEW_INCLUDE_DIR=${GLEW_INCLUDE_DIR}")  

FIND_LIBRARY(GLEW_LIBRARY
  NAMES glew32s glews GLEW 
  # glew32 glews glew GLEW Glew 
  PATHS 
  $ENV{GLEW_HOME}/lib
  $ENV{GLEW_DIR}/lib
  $ENV{EXTRA}/lib
  $ENV{EXTRA}
  $ENV{SOURCE_DIR}/glew/lib
  $ENV{SOURCE_DIR}/glew/
  C:/source/glew/lib
  D:/source/glew/lib
  /opt/net/gcc33/glew/lib
  /usr/lib
  /usr/local/lib
  )
#MESSAGE("DBG GLEW_LIBRARY=${GLEW_LIBRARY}")

## --------------------------------

IF(GLEW_LIBRARY)
  SET(GLEW_LIBRARIES ${GLEW_LIBRARY})
ELSE(GLEW_LIBRARY)
  MESSAGE(SEND_ERROR "GLEW library not found.")
ENDIF(GLEW_LIBRARY)

IF(NOT GLEW_INCLUDE_DIR)
  MESSAGE(SEND_ERROR "GLEW include dir not found.")
ENDIF(NOT GLEW_INCLUDE_DIR)


IF(GLEW_LIBRARIES AND GLEW_INCLUDE_DIR)

  SET(GLEW_FOUND TRUE)
  ## get the link directory for rpath to be used with LINK_DIRECTORIES: 	 
  GET_FILENAME_COMPONENT(GLEW_LINK_DIRECTORIES ${GLEW_LIBRARY} PATH)  
  
ELSE(GLEW_LIBRARIES AND GLEW_INCLUDE_DIR)
  SET(GLEW_FOUND FALSE)
ENDIF(GLEW_LIBRARIES AND GLEW_INCLUDE_DIR)


MARK_AS_ADVANCED(
  GLEW_INCLUDE_DIR
  GLEW_LIBRARY
  GLEW_LIBRARIES
  )
