##
## This file generates the bias library config header 
## bias_config.h (in BIAS_BINARY_DIR) automatically 
## from bias_config.h.in (in BIAS_SOURCE_DIR).
##
## from the appropriate ..._FOUND flags
##
## -------------------------------------------------------------------------
## @author Jan Woetzel <http://www.mip.informatik.uni-kiel.de/~jw> (11/2003)
## -------------------------------------------------------------------------

## set the in and out cmake configure files: 
SET(FILE_BIAS_CONFIG_H_IN "${BIAS_SOURCE_DIR}/bias_config.h.in")
SET(FILE_BIAS_CONFIG_H "${BIAS_BINARY_DIR}/bias_config.h")

## jw. bias_debug is almost INDEPENDANT of buikld type. But keep NDEBUG tec in mind!!!
# IF(${CMAKE_BUILD_TYPE} MATCHES Debug)
#  SET(BIAS_DEBUG ON) 
# ELSE(${CMAKE_BUILD_TYPE} MATCHES Debug)
#  SET(BIAS_DEBUG OFF) 
# ENDIF(${CMAKE_BUILD_TYPE} MATCHES Debug)


# save build seting for bias_config.h to switch to correct exapnsion of dllim/export on WIN32 builds. 
# was BIAS built shared or static?
IF(BUILD_SHARED_LIBS)
  SET(BIAS_BUILD_SHARED_LIBS ON)
ENDIF(BUILD_SHARED_LIBS)


##
## translate cmake ..._FOUND and USE_..  to  BIAS_HAVE_...
##
IF(BLAS_FOUND)
  SET(BIAS_HAVE_BLAS ON)
ENDIF(BLAS_FOUND)

IF(LAPACK_FOUND)
  SET(BIAS_HAVE_LAPACK ON)
ENDIF(LAPACK_FOUND)

IF(DEVIL_FOUND)
  SET(BIAS_HAVE_DEVIL ON)
ENDIF(DEVIL_FOUND)

IF(DV_FOUND)
  SET(BIAS_HAVE_DV ON)
ENDIF(DV_FOUND)

IF(FFTW3_FOUND)
  SET(BIAS_HAVE_FFTW3 ON)
ENDIF(FFTW3_FOUND)

IF(GLEW_FOUND)
  SET(BIAS_HAVE_GLEW ON)
ENDIF(GLEW_FOUND)

IF(GLUT_FOUND)
  SET(BIAS_HAVE_GLUT ON)
ENDIF(GLUT_FOUND)

IF(IMLIB_FOUND)
  SET(BIAS_HAVE_IMLIB ON)
ENDIF(IMLIB_FOUND)

IF(IMAGEMAGICKLIB_FOUND)
  SET(BIAS_HAVE_IMAGEMAGICKLIB ON)
ENDIF(IMAGEMAGICKLIB_FOUND)

IF(USE_DAIMLERCHRYSLER)
  SET(BIAS_DAIMLERCHRYSLER ON)
ENDIF(USE_DAIMLERCHRYSLER)

IF(OPENCV_FOUND)
  SET(BIAS_HAVE_OPENCV ON)
ENDIF(OPENCV_FOUND)

IF(OPENGL_FOUND)
  SET(BIAS_HAVE_OPENGL ON)
ENDIF(OPENGL_FOUND)

IF(OPENEXR_FOUND)
  SET(BIAS_HAVE_OPENEXR ON)
ENDIF(OPENEXR_FOUND)

IF(PTHREADS_FOUND OR UNIX)
  SET(BIAS_HAVE_PTHREADS ON)
ENDIF(PTHREADS_FOUND OR UNIX)

IF(STEREOI_FOUND)
  SET(BIAS_HAVE_STEREOI ON)
ENDIF(STEREOI_FOUND)

IF(WXWINDOWS_FOUND)
  SET(BIAS_HAVE_WXWINDOWS_FOUND ON)
ENDIF(WXWINDOWS_FOUND)



## deprecated: merged to BIAS/Base/Common/BIAS_DeclSpec.hh
SET(DLL_EXPORT "")
#IF(BUILD_SHARED_LIBS)
# SET(DLL_EXPORT "__declspec(dllexport)")
#ELSE(BUILD_SHARED_LIBS)
#  SET(DLL_EXPORT "/* __declspec(dllexport) we are in static mode*/")
#ENDIF(BUILD_SHARED_LIBS)


## generate .h from .h.in file
#MESSAGE("DBG generating ${FILE_BIAS_CONFIG_H}  (from ${FILE_BIAS_CONFIG_H_IN})")
CONFIGURE_FILE(${FILE_BIAS_CONFIG_H_IN} ${FILE_BIAS_CONFIG_H})
