/** OpenGL example for 
1. using multiple canvases sharing teh same canvas inlcuding didplay lists etc.
2. drawing text in OpenGL Using fonts.
Jan Woetzel */

#include <wx/wx.h>

//BIAS
#include <Gui/OpenGLCanvas.hh>
#ifdef WIN32
#  include <Gui/DrawTextGL.hh>
#endif

using namespace BIAS;
using namespace std;


// --------------------------------------------------------
/** @example ExampleGLShared.cpp
  Demonstrates 
  - usage of wx OpenGL canvas,
  - setting up a shared context,
  - using fonts with OpenGL in absolute and relative mode. Resize teh window to see the effect. 
JW */
class ExampleGLSharedApp 
	: public /*wxApp*/ wxGLApp
{
  virtual bool OnInit(); 
}; // end of ExampleGLSharedApp -----------------------


enum _ExampleGLSharedMyFrameIDs_ {
	ID_ABOUT=wxID_ABOUT,
	ID_QUIT
};


// --------------------------------------------------------


/** Implement your own OopenGLCanvas derived class
	and override one of the Display functions
	to plug in your own GL calls / GL scene
	@author Jan Woetzl */
class MyGLCanvas : public OpenGLCanvas {
public:
	MyGLCanvas(wxFrame* parent);

	/// constructor using a shared context 
	MyGLCanvas(
			wxFrame* parent
			,wxGLContext* sharedContext
			,wxWindowID id = -1
			,const wxPoint& pos = wxDefaultPosition
			,const wxSize& size = wxDefaultSize
			,long style=0
			,const wxString& name="MyGLCanvas sharedContext"
			,int* attribList = 0
			,const wxPalette& palette = wxNullPalette
			);

	// override to fire our own Display calls: 
	void DisplayCalls();

	//
	// additional members:
	//

	// additional function to load and init geometry, dipsla ylistst etc. JW
	void InitGeometry();

	// data mebers:
	int dplist;
#ifdef BIAS_HAVE_FONTGL
	DrawTextGL font;
#endif
};


class MyGLCanvas2 : public OpenGLCanvas {
public:
	MyGLCanvas2(wxFrame* parent);

	/// constructor using a shared context 
	MyGLCanvas2(
			wxFrame* parent
			,wxGLContext* sharedContext
			,wxWindowID id = -1
			,const wxPoint& pos = wxDefaultPosition
			,const wxSize& size = wxDefaultSize
			,long style=0
			,const wxString& name="MyGLCanvas sharedContext"
			,int* attribList = 0
			,const wxPalette& palette = wxNullPalette
			);

	// override to fire our own Display calls: 
	void DisplayCalls();

	int dplist;
};


// --------------------------------------------------------

class MyFrame: public wxFrame {
public:
  MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size);
  void OnQuit(wxCommandEvent& event);
  void OnAbout(wxCommandEvent& event);

  // data member ---
  //BIAS::OpenGLCanvas * p_canvas;
  MyGLCanvas * p_canvas;
  MyGLCanvas2 * p_2nd_canvas;

  DECLARE_EVENT_TABLE();
}; // end of MyFrame --------------------------------------

