/**	Simple example for BIAS::OpenGLCanvas(Base) usage.
@author: Jan Woetzel */

#include <Base/Common/LeakChecking.h>

#include "ExampleOpenGLCanvasBase.hh"

// BIAS
#include <Gui/ConsoleRedirectIO.hh>

using namespace std;

// required for wx RTTI dynamic construction: 
IMPLEMENT_APP(ExampleOpenGLCanvasApp);


// --------------------------------------------------------
bool ExampleOpenGLCanvasApp::OnInit()
{
	// utility: create a Redirection console for cout, cerr etc.
	ConsoleRedirectIO();
	// testing output: 
	cout<<"Hallo cout"<<endl;
	cout<<"Hallo cerr"<<endl;

	MyFrame *frame = new MyFrame( "ExampleOpenGLCanvasBase", wxPoint(0,0), wxSize(640,480) );
	frame->Show(TRUE);
	wxLogGui log;
	SetTopWindow(frame);

	return TRUE;
}


// --------------------------------------------------------
BEGIN_EVENT_TABLE(MyFrame, wxFrame)
EVT_MENU(ID_QUIT, MyFrame::OnQuit)
EVT_MENU(ID_ABOUT, MyFrame::OnAbout)
END_EVENT_TABLE()
// --------------------------------------------------------


MyFrame::MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size)
: wxFrame((wxFrame *)NULL, -1, title, pos, size)
,p_canvas(NULL)
{
	// Create a simple top Menu
	wxMenu *menuFile = new wxMenu;  
	menuFile->Append( ID_ABOUT, "&About..." );
	menuFile->AppendSeparator();
	menuFile->Append( ID_QUIT, "E&xit" );
	wxMenuBar *menuBar = new wxMenuBar;
	menuBar->Append(menuFile, "&File");
	SetMenuBar(menuBar);

	// Create a simple bottom status bar 
	CreateStatusBar(2);

	// Canvas to test: 
	p_canvas=new BIAS::OpenGLCanvasBase(this, -1);

}


void MyFrame::OnQuit(wxCommandEvent& ){ 
	Close(TRUE); 
}


void MyFrame::OnAbout(wxCommandEvent& )
{
	wxString title("About");
	wxString msg; // message
	msg<<"About - "<<FUNCNAME<<"\n";
	msg<<"author: Jan Woetzel (c) 2003-2005\n";
	msg<<"build: "<<__DATE__<<" "<<__TIME__<<"\n";
	msg<<"from "<<__FILE__<<"\n";
	msg<<"GUI using: "<<wxVERSION_STRING<<"\n";
	msg<<"\n";
	COUT(msg);
	wxMessageBox(msg, title, wxICON_INFORMATION | wxOK );
}

