// JW

#include "SettingsGL.hh"

#ifdef WIN32
// MS wgl extensions via GLEW
#  include <GL/wglew.h>
#else //WIN32
// Linux glx extensions via GLEW
//#include <GL/glxew.h>
#endif //WIN32

#include <Base/Debug/Error.hh>
#include <Base/Debug/DebugSimple.hh>


// ----------------------------------------------------------
// namespace stuff:
using namespace BIAS;
using namespace std;
// ----------------------------------------------------------

/** @author Jan Woetzel 04/2005 */


/** set the vsync swap interval */
void SettingsGL::SetVSyncInterval( const int & interval )
{
#ifdef WIN32
	if (WGLEW_EXT_swap_control) /* faster than wglewIsSupported(string) */
	{
		if (!wglSwapIntervalEXT(interval))
		{
			BIASERR("error on wglSwapIntervalEXT");
		}
		CHECK_GL_ERROR;
		return;
	} else {	
		BIASERR("WGLEW_EXT_swap_control not supported.");
	};
#else // WIN32
	BIASERR("Sorry, not implemented. Look at glXSwapInterval or AGL_SWAP_INTERVAL. (JW)");
	// possibly glewXGetVideoSyncSGI ???
	//if (GLXEW_SGI_swap_control)
	//{
	//glXSwapIntervalSGI( interval);
	// //or: glXWaitVideoSyncSGI(1,0,&interval)
	//	//glXSwapInterval( interval );
	//	CHECK_GL_ERROR;
	//	return;
	//} else {	
	//	BIASERR("GLXEW_SGI_swap_control not supported.");
	//};
#endif // WIN32
}



/** returns the swap control interval JW */
int  SettingsGL::GetVSyncInterval()
{
	int interval = -2;
#ifdef WIN32
	if(wglewIsSupported("WGL_EXT_swap_control"))
	{
		interval = wglGetSwapIntervalEXT();
		CHECK_GL_ERROR;
	} else {
		BIASERR("WGLEW_EXT_swap_control not supported.");
	};
#else // WIN32
	BIASERR("Sorry, not implemented/tested. (JW)");
	//if (GLXEW_SGI_swap_control)
	//{
	//  interval=glXGetSwapIntervalSGI();
	//	CHECK_GL_ERROR;
	//} else {
	//	string msg("Error: GLXEW_SGI_swap_control not supported.");
	//	BIASERR(msg);
	//	::wxMessageBox(msg.c_str());
	//};
#endif // WIN32
	return interval;
}

