#include "Image/Contour.hh"
#include "Base/Image/ImageIO.hh"
#include "Base/Debug/TimeMeasure.hh"

using namespace BIAS;
using namespace std;

int main(int argc, char** argv)
{

 Image<unsigned char> image1, out;
  int res;
  if (argc <2) {
    cerr<<"usage: "<< argv[0] <<" <segmented pgm file> "<<endl;
    exit(1);
  }

  if ((res=ImageIO::ImportImage(argv[1], image1)) != 0){
    cerr << "error loading file " << argv[1] << "   " << res << endl;
    exit (-1);
  }

  if (image1.GetChannelCount() != 1){
    cerr << "wrong channel count in image"<< endl;
  }
  
  Contour cont;
  out=image1;
  TimeMeasure timer;
  timer.Start();
  cont.Process(image1);
  timer.Stop();
  std::cout<<"Finding the contour did take: ";
  timer.PrintRealTime();
  out.FillImageWithConstValue((unsigned char)0);
  cont.Draw(out);
  if (ImageIO::ExportImage("contour", out, ImageIO::FF_ppm)!=0){
    BIASERR("error writing");
  }
  cout<<"FreemanCode of Contour:"<<endl;
  for (unsigned int i=0;i<cont.GetFreemanCode().size();i++)
    cout<<cont.GetFreemanCode()[i]<<" ";
  cout<<endl;
  cout<<"written contour.pgm"<<endl;
}
