/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// TODO deprecated file 

#ifndef __IterativExtendedKalman3DPoint_hh__
#define __IterativExtendedKalman3DPoint_hh__

#include "Base/Geometry/HomgPoint2D.hh"
#include "Base/Geometry/HomgPoint3D.hh"
#include "Base/Geometry/PMatrixBase.hh"
#include "Base/Math/Matrix3x3.hh"

namespace BIAS {
  

  /** estimates the 3D point X and updates the apriori error covariance 
      matrix L
      using a iterative extended Kalman Filter with respect to the 
      measurent x and the "measurement function" P. Delta_h is the Jacobian of 
      "normnalized" P at position X
      
      The measurment noise covariance matrix R should be input as well:
      It could be the quality from the corner detector, but this is not 
      implemented yet
      
      added diffusion, woelk 01 2003
      
      input: x, P, L
      output: X, L 
      @author Felix Woelk */
  extern void 
  IterativExtendedKalman3DPoint(const HomgPoint2D& x, const PMatrixBase& P, 
                                HomgPoint3D& X, Matrix3x3<double>& L,
                                double MeasurementNoise=2.0, 
                                unsigned int NumIterations=3, 
                                double DiffusionFactor=1.0);

 
}// namespace


#endif // 
