///
/// *WAS*: once upon a time... generated from /home/evers/bin/generatedeclspec.sh 
/// *NOW*: is hand edited.
///
/// TODO: the expansion of the macros has to be different (discussion between Ischilelr and jw on 2005/11/01
/// case 1: Linux. expand to nothing, no differnec betwen static and shared build
///
/// case 2: Windows:
/// case 2.1: On compilation:
/// case 2.1.1: static : expand to nothing
/// case 2.1.2: shared : expand to ...export (becau it i scurrentyl compiled)
///
/// case 2.2: On using teh headers/linking against this by third party lib: 
/// case 2.2.1: was static build : expand to nothing
/// case 2.2.2: was shared build : expand to ...import (because it *was* compiled as a dll with export)
///
/// Thus on *usage* of this file we need to know if we are using u shared or a stici build.
/// This can be saved and uncluded through bias_config.h (I think)
///
/// @author Jan Woetzel 2005/11/01
///

#include <bias_config.h>



#if defined (WIN32) && defined(BIAS_BUILD_SHARED_LIBS) 

/// we need to define export on compilation  or import on use.
/// We exploit that cmakes auto setting xxx_EXPORTS (with S) on compliation
/// 
/// We need to write one switches for each built lib explicitly 
/// because nested macros dont work with preprocessor. 
/// Jan Woetzel, 2005


#  ifdef BIASCommon_EXPORTS 
#    define BIASCommon_EXPORT __declspec(dllexport)
#  else  
#    define BIASCommon_EXPORT __declspec(dllimport)
#  endif 

#  ifdef BIASDebug_EXPORTS 
#    define BIASDebug_EXPORT __declspec(dllexport)
#  else  
#    define BIASDebug_EXPORT __declspec(dllimport)
#  endif 

#  ifdef BIASFeatureDetector_EXPORTS 
#    define BIASFeatureDetector_EXPORT __declspec(dllexport)
#  else  
#    define BIASFeatureDetector_EXPORT __declspec(dllimport)
#  endif 

#  ifdef BIASFilter_EXPORTS
#    define BIASFilter_EXPORT __declspec(dllexport)
#  else  
#    define BIASFilter_EXPORT __declspec(dllimport)
#  endif 

#  ifdef BIASGeometry_EXPORTS 
#    define BIASGeometry_EXPORT __declspec(dllexport)
#  else  
#    define BIASGeometry_EXPORT __declspec(dllimport)
#  endif 

#  ifdef BIASGeometryBase_EXPORTS 
#    define BIASGeometryBase_EXPORT __declspec(dllexport)
#  else  
#    define BIASGeometryBase_EXPORT __declspec(dllimport)
#  endif 

#  ifdef BIASGui_EXPORTS 
#    define BIASGui_EXPORT __declspec(dllexport)
#  else  
#    define BIASGui_EXPORT __declspec(dllimport)
#  endif 

#  ifdef BIASImage_EXPORTS 
#    define BIASImage_EXPORT __declspec(dllexport)
#  else  
#    define BIASImage_EXPORT __declspec(dllimport)
#  endif 

#  ifdef BIASImageBase_EXPORTS 
#    define BIASImageBase_EXPORT __declspec(dllexport)
#  else  
#    define BIASImageBase_EXPORT __declspec(dllimport)
#  endif 

#  ifdef BIASMatcher2D_EXPORTS 
#    define BIASMatcher2D_EXPORT __declspec(dllexport)
#  else  
#    define BIASMatcher2D_EXPORT __declspec(dllimport)
#  endif 

#  ifdef BIASMathAlgo_EXPORTS 
#    define BIASMathAlgo_EXPORT __declspec(dllexport)
#  else  
#    define BIASMathAlgo_EXPORT __declspec(dllimport)
#  endif 

#  ifdef BIASMathBase_EXPORTS 
#    define BIASMathBase_EXPORT __declspec(dllexport)
#  else  
#    define BIASMathBase_EXPORT __declspec(dllimport)
#  endif 

#  ifdef BIASStateEstimator_EXPORTS 
#    define BIASStateEstimator_EXPORT __declspec(dllexport)
#  else  
#    define BIASStateEstimator_EXPORT __declspec(dllimport)
#  endif 

#  ifdef BIASUtils_EXPORTS 
#    define BIASUtils_EXPORT __declspec(dllexport)
#  else  
#    define BIASUtils_EXPORT __declspec(dllimport)
#  endif 



///
/// getting the export for DTL into DLLs is quite tricky on MS Windows.
/// We use "manual" explicit instantiation fo reach interfaced class variable
///
/// See http://support.microsoft.com/kb/q168958/
/// and
/// http://www.unknownroad.com/rtfm/VisualStudio/warningC4251.html
///
///
/// See BIAS/Filter/Label.hh for usage example. 
///
/// @author Jan Woetzel 2005/11/02
///
#define BIAS_EXPORT_STL_VECTOR( dllmacro, vectype ) \
  template class dllmacro std::allocator< vectype >; \
  template class dllmacro std::vector<vectype, \
    std::allocator< vectype > >;


// JW 
#define BIAS_EXPORT_STL_SET( dllmacro, settype ) \
  template class dllmacro std::allocator< settype >; \
  template struct dllmacro std::less< settype >; \
  template class dllmacro std::allocator< \
    std::_Tree_nod<std::_Tset_traits<settype,std::less<settype>, \
    std::allocator<settype>,false> > >; \
  template class dllmacro std::allocator<  \
    std::_Tree_ptr<std::_Tset_traits<settype,std::less<settype>, \
    std::allocator<settype>,false> > >; \
  template class dllmacro std::_Tree_ptr< \
    std::_Tset_traits<settype,std::less<settype>, \
    std::allocator<settype>,false> >; \
  template class dllmacro std::_Tree_nod< \
    std::_Tset_traits<settype,std::less<settype>, \
    std::allocator<settype>,false> >; \
  template class dllmacro std::_Tree_val< \
    std::_Tset_traits<settype,std::less<settype>, \
    std::allocator<settype>,false> >; \
  template class dllmacro std::set< settype, std::less< settype >, \
    std::allocator< settype > >;


// JW 
#define BIAS_EXPORT_STL_MAP( dllmacro, mapkey, mapvalue ) \
  template struct dllmacro std::pair< mapkey,mapvalue >; \
  template class dllmacro std::allocator< \
    std::pair<const mapkey,mapvalue> >; \
  template struct dllmacro std::less< mapkey >; \
  template class dllmacro std::allocator< \
    std::_Tree_ptr<std::_Tmap_traits<mapkey,mapvalue,std::less<mapkey>, \
    std::allocator<std::pair<const mapkey,mapvalue> >,false> > >; \
  template class dllmacro std::allocator< \
    std::_Tree_nod<std::_Tmap_traits<mapkey,mapvalue,std::less<mapkey>, \
    std::allocator<std::pair<const mapkey,mapvalue> >,false> > >; \
  template class dllmacro std::_Tree_nod< \
    std::_Tmap_traits<mapkey,mapvalue,std::less<mapkey>, \
    std::allocator<std::pair<const mapkey,mapvalue> >,false> >; \
  template class dllmacro std::_Tree_ptr< \
    std::_Tmap_traits<mapkey,mapvalue,std::less<mapkey>, \
    std::allocator<std::pair<const mapkey,mapvalue> >,false> >; \
  template class dllmacro std::_Tree_val< \
    std::_Tmap_traits<mapkey,mapvalue,std::less<mapkey>, \
	std::allocator<std::pair<const mapkey,mapvalue> >,false> >; \
  template class dllmacro std::map< \
    mapkey, mapvalue, std::less< mapkey >, \
    std::allocator<std::pair<const mapkey,mapvalue> > >;



#  else // (WIN32) && defined(BIAS_BUILD_SHARED_LIBS) ---------------------

// we are either running Linux or building static, 
// thus expand to nothing
// Jan Woetzel

#    define BIASCommon_EXPORT
#    define BIASDebug_EXPORT
#    define BIASFeatureDetector_EXPORT
#    define BIASFilter_EXPORT
#    define BIASGeometry_EXPORT
#    define BIASGeometryBase_EXPORT
#    define BIASGui_EXPORT
#    define BIASImage_EXPORT
#    define BIASImageBase_EXPORT
#    define BIASMatcher2D_EXPORT
#    define BIASMathAlgo_EXPORT
#    define BIASMathBase_EXPORT
#    define BIASStateEstimator_EXPORT
#    define BIASUtils_EXPORT


// DLL: nothing to export (Jan Woetzel)
#define BIAS_EXPORT_STL_VECTOR( dllmacro, vectype ) 
#define BIAS_EXPORT_STL_SET( dllmacro, settype ) 
#define BIAS_EXPORT_STL_MAP( dllmacro, mapkey, mapvalue ) 


#endif // (WIN32) && defined(BIAS_BUILD_SHARED_LIBS)  ---------------------

